using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Tooltip_Offset_Bug
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.MdiClientHooked = false;
        }

        private bool MdiClientHooked;

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.HookMdiClient();

            Form2 child = new Form2();
            child.MdiParent = this;
            child.Show();
        }

        private void HookMdiClient(){
            foreach (Control item in this.Controls) {
                if (item is MdiClient) {
                    this.HookMdiClientEvents((MdiClient)item);
                }
            }
        }

        private void HookMdiClientEvents(MdiClient client){
            if (this.MdiClientHooked) {
                return;
            } else {
                client.ControlAdded += new ControlEventHandler(client_ControlAdded);
                this.MdiClientHooked = true;
            }
        }

        void  client_ControlAdded(object sender, ControlEventArgs e)
        {
            Form child = e.Control as Form;
            if (child != null) {
                this.addFormTab(child);
            }
        }

        private void addFormTab(Form child)
        {
 	        child.FormBorderStyle = FormBorderStyle.None;
            this.addTab((Control)child);
        }

        private void addTab(Control child){
            TabPage page = new TabPage(child.Text);
            page.Controls.Add(child);
            page.Name = child.Text;
            child.Name = child.Text;
            page.ToolTipText = child.Text;
            child.Dock = DockStyle.Fill;
            child.Visible = true;
            page.AutoScroll = true;
            page.Enabled = child.Enabled;

            this.tabControl1.TabPages.Add(page);
            this.tabControl1.SelectTab(page.Name);
        }
    }
}